Bug 464037 - context_free() is a bad name for a global symbol
context_free() is a bad name for a global symbol
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: libselinux (Show other bugs)
12
All Linux
medium Severity high
: ---
: ---
Assigned To: Daniel Walsh
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-09-25 20:18 EDT by David Woodhouse
Modified: 2010-12-05 02:08 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-12-05 02:08:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description David Woodhouse 2008-09-25 20:18:11 EDT
libselinux.so seems to get pulled in to lots of unsuspecting applications and libraries.... like the OpenSSL TPM engine, for example.

It has a global function named context_free().

This is not clever.
Comment 1 Daniel Walsh 2008-09-29 14:46:21 EDT
I agree, but it is rather difficult to change at this point.  libselinux did not do a good job of namespacing.
Comment 2 David Woodhouse 2008-09-29 14:58:28 EDT
It would be good to change. It's causing unsuspecting applications to crash.
Comment 3 Daniel Walsh 2008-09-29 15:37:44 EDT
But if the function is already called by other non SELinux programs, pam, ssh, cron, coreutils  It is not easy to remove/change.
Comment 4 Stephen Smalley 2008-09-29 16:01:50 EDT
See
http://marc.info/?t=117882818800005&r=1&w=2

I'd recommend taking it up again on selinux list, preferably with patches to introduce the new prefixed interfaces and to deprecate the old ones.  Then some day we can actually drop them altogether.
Comment 5 David Woodhouse 2008-10-07 06:44:46 EDT
In the meantime, we are shipping packages in Fedora which segfault due to libselinux hijacking their internal functions....
Comment 6 Daniel Walsh 2008-10-08 18:01:28 EDT
Shouldn't they be handling this?  Isn't there a way for these tools to force the use of their internal function rather then using the libselinux global?
Comment 7 Ulrich Drepper 2008-10-08 18:17:16 EDT
The ELF lookup path is well defined.  It's easy enough for a program author to get the expected result.  libselinux works fine if a different context_free comes first in the lookup path because it doesn't use the PLT for internal calls.  So it is only a matter of always listing all dependencies on the linker command line and providing the -l option is the correct order.  Everything else just works fine.

In an ideal world libselinux would have all interfaces with a unique prefix.  But it is what it is and having incapable programmers is no justification for breaking binary compatibility.
Comment 8 Bug Zapper 2009-06-09 22:48:43 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Bug Zapper 2009-11-16 04:27:29 EST
This bug appears to have been reported against 'rawhide' during the Fedora 12 development cycle.
Changing version to '12'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Bug Zapper 2010-11-04 07:47:12 EDT
This message is a reminder that Fedora 12 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 12.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '12'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 12's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 12 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Bug Zapper 2010-12-05 02:08:00 EST
Fedora 12 changed to end-of-life (EOL) status on 2010-12-02. Fedora 12 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.